//***************************************************************
//  : main.c
// 汾     : V1.0 2019/04/09MQ6823
//      : 
// ע     : 24C02 R/W ,Ҳ"I2C_Slave"ͨ
//            
//***************************************************************
#ifndef IO_MEM
#define IO_MEM
#endif

#include "main.h"

/* ----------------------  ------------------------------ */
BIT_LIST_8  _flag_8bit;
BIT_LIST_16 _flag_16bit;
uchar       iloop, data, wBuf[16], rBuf[16];
uchar      wBuf_FF[] = { 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
							 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF};
/* ----------------------  -------------------------------- */
void main(){
    /* ---------------------- ϵͳʼ ------------------------ */
    SYSTEM_INIT();

	// 趨16ʵ write buffer data
    for( iloop=0; iloop<16; iloop++ ){
        wBuf[iloop]  = 0x10+iloop;
	}
    /* ---------------------- ܳʼ ------------------------ */ 
    I2C_Init();							// I2C, 8λֽ , Ack , ģʽ							
										// P23-SDA  P24-SCL
    delay_times(t_1ms, 1);
    
//----------------------------------------------------------------//
//----------------------------------------------------------------//

//  * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

//  Master operation
if(1){

		//-------------------------------------------------------------------------------------
    //  write sequence FF
    if(1){
        I2C_Start(0xa0, 0x00);			// Ϊģʽʼʹ1ֽ(1byte)(0x06)  
    //..........|.....| 0x00: 趨 slave start address
    //..........| 0xa0: 趨 slave Device ID, select AT24C02 EEPROM

        I2C_ByteWrite(wBuf_FF, 16); 	
        I2C_Stop();						// ֹͣ

        //...wait AT24C02 pgm time >5ms......................
        delay_times(t_1ms, 10);
    }
	
	    //  read sequence
	/*  step1): I2C_start(),趨slave Device ID,slave start address
	    step2): I2C_restart()
	    step3): I2C_ByteRead(sI2C.I2C_rBuf, data length)
	    step4): I2C_stop()
	*/
	
	//-------------------------------------------------------------------------------------------------------
    if(1){
        I2C_Start(0xa0, 0x00);			// Ϊģʽʼʹ1ֽ(1byte)(0x00)  
    //..........|.....| 0x00: 趨 slave start address
    //..........| 0xa0: 趨 slave Device ID, select AT24C02 EEPROM
        I2C_Restart(0xa1);          	// ظʼ

        I2C_ByteRead(rBuf, 10);     	//  10 
        I2C_Stop();						// ֹͣ
    }
	//-------------------------------------------------------------------------------------
    //  write sequence
    if(1){
        I2C_Start(0xa0, 0x00);			// Ϊģʽʼʹ1ֽ(1byte)(0x00)  
    //..........|.....| 0x00: 趨 slave start address
    //..........| 0xa0: 趨 slave Device ID, select AT24C02 EEPROM

        I2C_ByteWrite(wBuf, 3);     	//  3 
        I2C_Stop();						// ֹͣ

        //...wait AT24C02 pgm time >5ms......................
        delay_times(t_1ms, 10);
    }
	//-------------------------------------------------------------------------------------
    //  read sequence
    if(1){
        I2C_Start(0xa0, 0x00);			// Ϊģʽʼʹ1ֽ(1byte)(0x00)  
    //..........|.....| 0x00: 趨 slave start address
    //..........| 0xa0: 趨 slave Device ID, select AT24C02 EEPROM
        I2C_Restart(0xa1);          	// ظʼ

        I2C_ByteRead(rBuf, 10);     	//  10 
        I2C_Stop();						// ֹͣ
    }
	//-------------------------------------------------------------------------------------
    //  write sequence
    if(1){
        I2C_Start(0xa0, 0x06);			// Ϊģʽʼʹ1ֽ(1byte)(0x06)  
    //..........|.....| 0x06: 趨 slave start address
    //..........| 0xa0: 趨 slave Device ID, select AT24C02 EEPROM

        I2C_ByteWrite(wBuf, 2);     	//  2 
        I2C_Stop();						// ֹͣ

        //...wait AT24C02 pgm time >5ms......................
        delay_times(t_1ms, 10);
    }
	//-------------------------------------------------------------------------------------
    //  read sequence
    if(1){
        I2C_Start(0xa0, 0x00);			// Ϊģʽʼʹ1ֽ(1byte)(0x00)  
    //..........|.....| 0x00: 趨 slave start address
    //..........| 0xa0: 趨 slave Device ID, select AT24C02 EEPROM
        I2C_Restart(0xa1);          	// ظʼ

        I2C_ByteRead(rBuf, 10);     	//  10 
        I2C_Stop();
    }
	//-------------------------------------------------------------------------------------
    //  read sequence
    if(1){
        I2C_Start(0xa0, 0x05);			// Ϊģʽʼʹ1ֽ(1byte)(0x05)  
    //..........|.....| 0x05: 趨 slave start address
    //..........| 0xa0: 趨 slave Device ID, select AT24C02 EEPROM
        I2C_Restart(0xa1);          	// ظʼ

        I2C_ByteRead(rBuf, 10);     	//  10 
        I2C_Stop();
    }
	

	//-------------------------------------------------------------------------------------
	
	//-------------------------------------------------------------------------------------
    //  I2C master do loop
    while(1){
        CLR_WDT;						// Źʱ (ι)
    }

}
//  Master operation
//  * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

}


















/*---------------------- жϷ ------------------------*/
//=============== Dummy function for interrupt ============
void __interrupt Int_dummy(void)
{

}
//=========================================================


void __interrupt OnlyReti(void)
{
    NOP;                                // ָ
}

void __interrupt_n OnlyRetn(void)
{
    NOP;                                // ָ
}

void __interrupt_n IntWDT(void)
{
    NOP;                                // ָ
}

void __interrupt_n IntSWI(void)
{
    unsigned char tmp;
    tmp =*(unsigned char*)(0xf000);
    while(tmp != *(unsigned char*)(0xf000))
    {
        tmp =*(unsigned char*)(0xf000);
    }
    SYSCR2 = 0x10;                      // system clock reset
}
/*-----------------  жϷ ------------------------*/

/*---------------------- MQ6823ж --------------------*/
#pragma section const INT_VECTOR1
void * const IntTbl1[] = {
    Int_dummy,          // 0xffc0 : Reserved
    Int_dummy,          // 0xffc2 : Reserved
    OnlyReti,           // 0xffc4 : IntTCC1P
    OnlyReti,           // 0xffc6 : IntTCC1T
    OnlyReti,           // 0xffc8 : IntTCA1
    Int_dummy,          // 0xffca : Reserved
    Int_dummy,          // 0xffcc : Reserved
    Int_dummy,          // 0xffce : Reserved
    OnlyReti,           // 0xffd0 : IntTXD1
    OnlyReti,           // 0xffd2 : IntRXD1
    Int_dummy,          // 0xffd4 : Reserved
    Int_dummy,          // 0xffd6 : Reserved
    OnlyReti,          	// 0xffd8 : Int3 / IntEMG1
    OnlyReti,           // 0xffda : Int2 
    OnlyReti,           // 0xffdc : Int1
    OnlyReti,           // 0xffde : Int0
    OnlyReti,           // 0xffe0 : IntSBI
    OnlyReti,           // 0xffe2 : IntTCA0
    OnlyReti,           // 0xffe4 : IntTC01
    OnlyReti,           // 0xffe6 : IntTC00
    OnlyReti,           // 0xffe8 : IntRTC
    OnlyReti,           // 0xffea : IntADC
    OnlyReti,           // 0xffec : IntVLTD
    OnlyReti,           // 0xffee : IntTXD0
    OnlyReti,           // 0xfff0 : IntRXD0
    OnlyReti,           // 0xfff2 : IntSIO0
    OnlyReti,           // 0xfff4 : IntTBT
    OnlyReti,           // 0xfff6 : IntWUC
    IntWDT,             // 0xfff8 : IntWDT
    (void *)0xffff,     // 0xfffa : Reserved
    IntSWI,             // 0xfffc : IntSWI / INTUNDEF
    STARTUP             // 0xfffe : RESET
};
#pragma section const
/*-------------------  MQ6823ж -------------------*/








//*********************************************************************
//    : SYSTEM_INIT(void)
//  : IO, CGCR ʼ P10/P40/P41 ڷʱ֮趨
// ע     :
//*********************************************************************
void SYSTEM_INIT(void)
{
#ifdef _DEBUG   //...  _DEBUG(ģʽ): ڷ ev board
//------------------------------------------------------------------
//  (ϵͳĬ): ʱP10趨ΪReset PinԱӰ漰¼.
//  SET_P10_to_RESET_PIN;
//------------------------------------------------------------------
    FSCTRL_FSSEL = 0;                   // 0ΪĬֵбλ(bit)ڷģʽֶʼΪĬֵ 0
//------------------------------------------------------------------
#else           //...  һϵܳ(Ƿģʽ) P10(RESET) λΪһ IO 
//------------------------------------------------------------------
//-- P10趨ΪһIO ------
    SET_P10_to_IO_PIN;
//------------------------------------------------------------------
#endif



//-- ʼ IO  (λ)------
#ifdef _DEBUG   //...  _DEBUG: ڷ ev board
//------------------------------------------------------------------
//   P10/P40/P41  Debug modeڷʱ趨Ϊ룬
//  ԱӰ漰¼.
    P1DR = 0x00;
    P1CR = set8bit(11111110);           //  P10 Ϊ
    P4DR = 0x00;
    P4CR = set8bit(11111100);           //  P40/P41 Ϊ
//------------------------------------------------------------------
#else           //...  һϵܳ(Ƿģʽ)
//------------------------------------------------------------------
    P1DR = 0x00;
    P1CR = 0xff;
    P4DR = 0x00;
    P4CR = 0xff;
//------------------------------------------------------------------
#endif

//-- ʼ IO  ------
    P0DR = 0x00;
    P0CR = 0xff;
//  P1DR = 0x00;
//  P1CR = 0xff;
    P2DR = 0x00;
    P2CR = 0xff;
//  P4DR = 0x00;
//  P4CR = 0xff;
    P5DR = 0x00;
    P5CR = 0xff;
    P7DR = 0x00;
    P7CR = 0xff;
    P8DR = 0x00;
    P8CR = 0xff;
    P9DR = 0x00;
    P9CR = 0xff;

    CLR_WDT;                            // Źʱ (ι)
}

//*********************************************************************
//    : delay_times
//  : ʱ
// ע     : ==> t_1ms   = 0;          // ӳʱ䵥λ ms
//          : ==> t_100us = 1;          // ӳʱ䵥λ usϴ
//          : ɹ̶Ȧʱһʱ䣬ʹ÷£
//          : delay_times(t_1ms, 800);  // ӳ 800ms
//*********************************************************************
void delay_times(uchar tBase, uint x)
{
    uint  i, cgcrT;

//  uchar cgcrF[4]={ 2, 4,  8, 1 };     // پƵΪ  8MHz ʱʹô
    uchar cgcrF[4]={ 4, 8, 16, 2 };     // پƵΪ 16MHz ʱʹô

//  ϵͳڸʱ(ͨ1ͨ2ģʽ) ʱ
    if( SYSCR2_SYSCK == 0 )
    {
        cgcrT = cgcrF[CGCR_FCGCKSEL];   // 0:fc/4, 1:fc/2, 2:fc/1, 3:fc/8
        switch(tBase)
        {
            case 0:                     // t_1ms
                cgcrT *= 110;
                for(; x>0; x--)
                    for(i=0; i<cgcrT; i++){}
            break;
            case 1:                     // t_100us
                cgcrT *= 11;
                for(; x>0; x--)
                    for(i=0; i<cgcrT; i++){}
            break;
        }
    }
//  ϵͳڵʱ(12ģʽ) ʱϴ󣬲οʹã
    else for(; x>0; x--){}

    CLR_WDT;                            // Źʱ (ι)
}
